/*
 * The FUJABA ToolSuite project:
 *
 *   FUJABA is the acronym for 'From Uml to Java And Back Again'
 *   and originally aims to provide an environment for round-trip
 *   engineering using UML as visual programming language. During
 *   the last years, the environment has become a base for several
 *   research activities, e.g. distributed software, database
 *   systems, modelling mechanical and electrical systems and
 *   their simulation. Thus, the environment has become a project,
 *   where this source code is part of. Further details are avail-
 *   able via http://www.fujaba.de
 *
 *      Copyright (C) 1997-2004 Fujaba Development Group
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA 02111-1307, USA or download the license under
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * WARRANTY:
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Lesser General Public License for more details.
 *
 * Contact adress:
 *
 *   Fujaba Management Board
 *   Software Engineering Group
 *   University of Paderborn
 *   Warburgerstr. 100
 *   D-33098 Paderborn
 *   Germany
 *
 *   URL  : http://www.fujaba.de
 *   email: info@fujaba.de
 *
 */
package de.uni_paderborn.fujaba.codegen;



/**
 * Class OOCollectionEnum
 *
 * @author    $Author: schneider $
 * @version   $Revision: 1.13 $
 */
public class OOCollectionEnum
    implements Comparable
{
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public final static OOCollectionEnum KEY_VALUE_PAIR = new OOCollectionEnum (-4);
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public final static OOCollectionEnum LIST_ITERATOR = new OOCollectionEnum (-3);
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public final static OOCollectionEnum ITERATOR = new OOCollectionEnum (-2);
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public final static OOCollectionEnum HASHTABLE = new OOCollectionEnum (-1);
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public final static OOCollectionEnum SET = new OOCollectionEnum (0);
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public final static OOCollectionEnum LIST = new OOCollectionEnum (SET);
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public final static OOCollectionEnum MAP = new OOCollectionEnum (LIST);
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public final static OOCollectionEnum MULTI_MAP = new OOCollectionEnum (MAP);
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public final static OOCollectionEnum TREESET = new OOCollectionEnum (MULTI_MAP);
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public final static OOCollectionEnum SORTED_MAP = new OOCollectionEnum (LIST);
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public final static OOCollectionEnum SORTED_MULTI_MAP = new OOCollectionEnum (MAP);


   /**
    * Default Constructor
    *
    * @param nr  No description provided
    */
   private OOCollectionEnum (int nr)
   {
      this.nr = nr;
   }


   /**
    * Constructor for class OOCollectionEnum
    *
    * @param prev  No description provided
    */
   private OOCollectionEnum (OOCollectionEnum prev)
   {
      this.nr = prev.nr + 1;
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private int nr = 0;


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @param other  No description provided
    * @return       No description provided
    */
   public boolean equals (Object other)
   {
      return  (this.compareTo (other) == 0);
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @param other  No description provided
    * @return       No description provided
    */
   public int compareTo (Object other)
   {
      return this.nr -  ((OOCollectionEnum) other).nr;
   }


   /**
    * @return   short string representation of current object
    */
   public String toString()
   {
      return "OOCollectionEnum[" + this.nr + "]";
   }

}

/*
 * $Log: OOCollectionEnum.java,v $
 * Revision 1.13  2004/10/20 17:49:32  schneider
 * Introduction of interfaces for class diagram classes
 *
 */
