/*
 * The FUJABA ToolSuite project:
 *
 *   FUJABA is the acronym for 'From Uml to Java And Back Again'
 *   and originally aims to provide an environment for round-trip
 *   engineering using UML as visual programming language. During
 *   the last years, the environment has become a base for several
 *   research activities, e.g. distributed software, database
 *   systems, modelling mechanical and electrical systems and
 *   their simulation. Thus, the environment has become a project,
 *   where this source code is part of. Further details are avail-
 *   able via http://www.fujaba.de
 *
 *      Copyright (C) 1997-2004 Fujaba Development Group
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA 02111-1307, USA or download the license under
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * WARRANTY:
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Lesser General Public License for more details.
 *
 * Contact adress:
 *
 *   Fujaba Management Board
 *   Software Engineering Group
 *   University of Paderborn
 *   Warburgerstr. 100
 *   D-33098 Paderborn
 *   Germany
 *
 *   URL  : http://www.fujaba.de
 *   email: info@fujaba.de
 *
 */
package de.uni_paderborn.fujaba.fsa.update;

import de.uni_paderborn.fujaba.uml.UMLLink;


/**
 * Translate int to String and back
 *
 * @author    $Author: lowende $
 * @version   $Revision: 1.16 $
 */
public class StringToModifierTranslator implements de.uni_paderborn.fujaba.fsa.update.Translator
{
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private static StringToModifierTranslator singleton = null;


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @return   No description provided
    */
   public static StringToModifierTranslator get()
   {
      if (singleton == null)
      {
         singleton = new StringToModifierTranslator();
      }

      return singleton;
   }


   /**
    * Constructor for class StringToModifierTranslator
    */
   private StringToModifierTranslator() { }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @param value  No description provided
    * @return       No description provided
    */
   public Object translateFsaToLogic (Object value)
   {
      if (value != null)
      {
         if (value.equals ('\u00AB' + "create" + '\u00BB'))
         {
            return new Integer (UMLLink.CREATE);
         }
         else if (value.equals ('\u00AB' + "destroy" + '\u00BB'))
         {
            return new Integer (UMLLink.DELETE);
         }
         else
         {
            return new Integer (UMLLink.NONE);
         }
      }
      else
      {
         return null;
      }

   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @param value  No description provided
    * @return       No description provided
    */
   public Object translateLogicToFsa (Object value)
   {
      if (value != null)
      {
         int modifier =  ((Integer) value).intValue();
         switch (modifier)
         {
            case UMLLink.NONE:
            {
               return "";
            }

            case UMLLink.CREATE:
            {
               return '\u00AB' + "create" + '\u00BB';
            }

            case UMLLink.DELETE:
            {
               return '\u00AB' + "destroy" + '\u00BB';
            }

            default:
            {
               return "";
            }
         }
      }
      return value;
   }

}

/*
 * $Log: StringToModifierTranslator.java,v $
 * Revision 1.16  2004/11/03 10:18:02  lowende
 * Javadoc warnings removed.
 *
 */
