package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class AssociationEngine
extends GFRNEngine
{
   private  AssociationEngine()
   {
   }

   private static AssociationEngine theAssociationEngine;

   public static AssociationEngine get()
   {
      if (theAssociationEngine == null)
      {
         theAssociationEngine = new AssociationEngine ();
      }
      return theAssociationEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation association = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         association = this.annotateUsingReferenceRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( association != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (association) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            association = this.annotateUsingReferenceRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( association != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (association) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               association = this.annotateUsingTrigger_AssocSetMethodRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( association != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (association) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  association = this.annotateUsingTrigger_AssocSetMethodRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               return (association) ;
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingReferenceRole(ASGElement asgElement)
   {
      AssocSetMethodAnnotation assocSetMethod3 = null ;
      AssocSetMethodAnnotation assocSetMethod5 = null ;
      AssociationAnnotation association = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAssocSetMethod3ElementsUMLMethod4 = null ;
      Iterator fujaba__IterAssocSetMethod3ElementsUMLMethod6 = null ;
      Iterator fujaba__IterAssocSetMethod5ElementsReference2 = null ;
      Iterator fujaba__IterReference1AnnotationsAssocSetMethod3 = null ;
      Iterator fujaba__IterReference1AnnotationsAssociation = null ;
      Iterator fujaba__IterUMLMethod4AnnotationsAssocSetMethod5 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference1 = null ;
      ReferenceAnnotation reference2 = null ;
      UMLMethod uMLMethod4 = null ;
      UMLMethod uMLMethod6 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("reference", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference1 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod3: AssocSetMethodAnnotation
            fujaba__IterReference1AnnotationsAssocSetMethod3 = reference1.iteratorOfAnnotations () ;
            while ( fujaba__IterReference1AnnotationsAssocSetMethod3.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference1AnnotationsAssocSetMethod3.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod3 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod3 and reference1
                  JavaSDM.ensure ( assocSetMethod3.hasInElements ("reference", reference1) ) ;
                   
                  // bind uMLMethod4: UMLMethod
                  fujaba__IterAssocSetMethod3ElementsUMLMethod4 = assocSetMethod3.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod3ElementsUMLMethod4.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod3ElementsUMLMethod4.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod4 = (UMLMethod) fujaba__TmpObject ;
                         
                        // bind uMLMethod6: UMLMethod
                        fujaba__IterAssocSetMethod3ElementsUMLMethod6 = assocSetMethod3.iteratorOfElements ("setMethod") ;
                        while ( fujaba__IterAssocSetMethod3ElementsUMLMethod6.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAssocSetMethod3ElementsUMLMethod6.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod6 = (UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod4.equals (uMLMethod6)) ) ;
                               
                              // bind assocSetMethod5: AssocSetMethodAnnotation
                              fujaba__IterUMLMethod4AnnotationsAssocSetMethod5 = uMLMethod4.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod4AnnotationsAssocSetMethod5.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod4AnnotationsAssocSetMethod5.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                    assocSetMethod5 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between assocSetMethod5 and uMLMethod4
                                    JavaSDM.ensure ( assocSetMethod5.hasInElements ("setMethod", uMLMethod4) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(assocSetMethod3.equals (assocSetMethod5)) ) ;
                                     
                                    // check To-Many-Link 'elements' between assocSetMethod5 and uMLMethod6
                                    JavaSDM.ensure ( assocSetMethod5.hasInElements ("calledMethod", uMLMethod6) ) ;
                                     
                                    // bind reference2: ReferenceAnnotation
                                    fujaba__IterAssocSetMethod5ElementsReference2 = assocSetMethod5.iteratorOfElements ("reference") ;
                                    while ( fujaba__IterAssocSetMethod5ElementsReference2.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAssocSetMethod5ElementsReference2.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                          reference2 = (ReferenceAnnotation) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(reference1.equals (reference2)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object reference1 is really bound
                                                JavaSDM.ensure ( reference1 != null ) ;
                                                 
                                                // check object reference2 is really bound
                                                JavaSDM.ensure ( reference2 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(reference1.equals (reference2)) ) ;
                                                 
                                                // bind association: AssociationAnnotation
                                                fujaba__IterReference1AnnotationsAssociation = reference1.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterReference1AnnotationsAssociation.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterReference1AnnotationsAssociation.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof AssociationAnnotation ) ;
                                                      association = (AssociationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between association and reference1
                                                      JavaSDM.ensure ( association.hasInElements ("reference", reference1) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between association and reference2
                                                      JavaSDM.ensure ( association.hasInElements ("reference", reference2) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference1 is really bound
                                                   JavaSDM.ensure ( reference1 != null ) ;
                                                    
                                                   // check object reference2 is really bound
                                                   JavaSDM.ensure ( reference2 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(reference1.equals (reference2)) ) ;
                                                    
                                                   // create object
                                                   association = new AssociationAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   association.setClassification (0);
                                                    
                                                   // create link
                                                   association.addToElements ("reference", reference1);
                                                    
                                                   // create link
                                                   association.addToElements ("reference", reference2);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference1 is really bound
                                                   JavaSDM.ensure ( reference1 != null ) ;
                                                    
                                                   // check object reference2 is really bound
                                                   JavaSDM.ensure ( reference2 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(reference1.equals (reference2)) ) ;
                                                    
                                                   // check object assocSetMethod3 is really bound
                                                   JavaSDM.ensure ( assocSetMethod3 != null ) ;
                                                    
                                                   // check object assocSetMethod5 is really bound
                                                   JavaSDM.ensure ( assocSetMethod5 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(assocSetMethod3.equals (assocSetMethod5)) ) ;
                                                    
                                                   // check object association is really bound
                                                   JavaSDM.ensure ( association != null ) ;
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (reference1);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (reference2);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (assocSetMethod3);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (assocSetMethod5);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (association) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object association is really bound
            JavaSDM.ensure ( association != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("reference", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (association) ;
   }


   private GFRNAnnotation annotateUsingTrigger_AssocSetMethodRole(ASGElement asgElement)
   {
      AssocSetMethodAnnotation assocSetMethod15 = null ;
      AssocSetMethodAnnotation assocSetMethod17 = null ;
      AssociationAnnotation association = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAssocSetMethod15ElementsReference13 = null ;
      Iterator fujaba__IterAssocSetMethod15ElementsUMLMethod16 = null ;
      Iterator fujaba__IterAssocSetMethod15ElementsUMLMethod18 = null ;
      Iterator fujaba__IterAssocSetMethod17ElementsReference14 = null ;
      Iterator fujaba__IterReference14AnnotationsAssociation = null ;
      Iterator fujaba__IterUMLMethod16AnnotationsAssocSetMethod17 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference13 = null ;
      ReferenceAnnotation reference14 = null ;
      UMLMethod uMLMethod16 = null ;
      UMLMethod uMLMethod18 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_AssocSetMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssocSetMethodAnnotation ) ;
             
            // explicit type cast
            assocSetMethod15 = (AssocSetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind reference13: ReferenceAnnotation
            fujaba__IterAssocSetMethod15ElementsReference13 = assocSetMethod15.iteratorOfElements ("reference") ;
            while ( fujaba__IterAssocSetMethod15ElementsReference13.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssocSetMethod15ElementsReference13.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                  reference13 = (ReferenceAnnotation) fujaba__TmpObject ;
                   
                  // bind uMLMethod16: UMLMethod
                  fujaba__IterAssocSetMethod15ElementsUMLMethod16 = assocSetMethod15.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod15ElementsUMLMethod16.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod15ElementsUMLMethod16.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod16 = (UMLMethod) fujaba__TmpObject ;
                         
                        // bind uMLMethod18: UMLMethod
                        fujaba__IterAssocSetMethod15ElementsUMLMethod18 = assocSetMethod15.iteratorOfElements ("setMethod") ;
                        while ( fujaba__IterAssocSetMethod15ElementsUMLMethod18.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAssocSetMethod15ElementsUMLMethod18.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod18 = (UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod16.equals (uMLMethod18)) ) ;
                               
                              // bind assocSetMethod17: AssocSetMethodAnnotation
                              fujaba__IterUMLMethod16AnnotationsAssocSetMethod17 = uMLMethod16.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod16AnnotationsAssocSetMethod17.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod16AnnotationsAssocSetMethod17.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                    assocSetMethod17 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between assocSetMethod17 and uMLMethod16
                                    JavaSDM.ensure ( assocSetMethod17.hasInElements ("setMethod", uMLMethod16) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(assocSetMethod15.equals (assocSetMethod17)) ) ;
                                     
                                    // check To-Many-Link 'elements' between assocSetMethod17 and uMLMethod18
                                    JavaSDM.ensure ( assocSetMethod17.hasInElements ("calledMethod", uMLMethod18) ) ;
                                     
                                    // bind reference14: ReferenceAnnotation
                                    fujaba__IterAssocSetMethod17ElementsReference14 = assocSetMethod17.iteratorOfElements ("reference") ;
                                    while ( fujaba__IterAssocSetMethod17ElementsReference14.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAssocSetMethod17ElementsReference14.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                          reference14 = (ReferenceAnnotation) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(reference13.equals (reference14)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object reference13 is really bound
                                                JavaSDM.ensure ( reference13 != null ) ;
                                                 
                                                // check object reference14 is really bound
                                                JavaSDM.ensure ( reference14 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(reference13.equals (reference14)) ) ;
                                                 
                                                // bind association: AssociationAnnotation
                                                fujaba__IterReference14AnnotationsAssociation = reference14.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterReference14AnnotationsAssociation.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterReference14AnnotationsAssociation.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof AssociationAnnotation ) ;
                                                      association = (AssociationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between association and reference14
                                                      JavaSDM.ensure ( association.hasInElements ("reference", reference14) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between association and reference13
                                                      JavaSDM.ensure ( association.hasInElements ("reference", reference13) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference13 is really bound
                                                   JavaSDM.ensure ( reference13 != null ) ;
                                                    
                                                   // check object reference14 is really bound
                                                   JavaSDM.ensure ( reference14 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(reference13.equals (reference14)) ) ;
                                                    
                                                   // create object
                                                   association = new AssociationAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   association.setClassification (0);
                                                    
                                                   // create link
                                                   association.addToElements ("reference", reference13);
                                                    
                                                   // create link
                                                   association.addToElements ("reference", reference14);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference13 is really bound
                                                   JavaSDM.ensure ( reference13 != null ) ;
                                                    
                                                   // check object reference14 is really bound
                                                   JavaSDM.ensure ( reference14 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(reference13.equals (reference14)) ) ;
                                                    
                                                   // check object assocSetMethod15 is really bound
                                                   JavaSDM.ensure ( assocSetMethod15 != null ) ;
                                                    
                                                   // check object assocSetMethod17 is really bound
                                                   JavaSDM.ensure ( assocSetMethod17 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(assocSetMethod15.equals (assocSetMethod17)) ) ;
                                                    
                                                   // check object association is really bound
                                                   JavaSDM.ensure ( association != null ) ;
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (reference13);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (reference14);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (assocSetMethod15);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (assocSetMethod17);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (association) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object association is really bound
            JavaSDM.ensure ( association != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_AssocSetMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (association) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("reference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("reference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof AssocSetMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_AssocSetMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof AssocSetMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_AssocSetMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      AssocSetMethodAnnotation assocSetMethod25 = null ;
      AssocSetMethodAnnotation assocSetMethod27 = null ;
      AssocSetMethodAnnotation assocSetMethod28 = null ;
      AssocSetMethodAnnotation assocSetMethod30 = null ;
      AssocSetMethodAnnotation assocSetMethod32 = null ;
      AssocSetMethodAnnotation assocSetMethod33 = null ;
      AssocSetMethodAnnotation assocSetMethod35 = null ;
      AssocSetMethodAnnotation assocSetMethod36 = null ;
      AssocSetMethodAnnotation assocSetMethod38 = null ;
      AssocSetMethodAnnotation assocSetMethod40 = null ;
      AssocSetMethodAnnotation assocSetMethod41 = null ;
      AssocSetMethodAnnotation assocSetMethod43 = null ;
      AssocSetMethodAnnotation assocSetMethod46 = null ;
      AssocSetMethodAnnotation assocSetMethod48 = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAssocSetMethod25ElementsUMLMethod26 = null ;
      Iterator fujaba__IterAssocSetMethod28ElementsUMLMethod29 = null ;
      Iterator fujaba__IterAssocSetMethod28ElementsUMLMethod31 = null ;
      Iterator fujaba__IterAssocSetMethod33ElementsUMLMethod34 = null ;
      Iterator fujaba__IterAssocSetMethod36ElementsUMLMethod37 = null ;
      Iterator fujaba__IterAssocSetMethod36ElementsUMLMethod39 = null ;
      Iterator fujaba__IterAssocSetMethod41ElementsUMLMethod42 = null ;
      Iterator fujaba__IterAssocSetMethod43ElementsUMLMethod44 = null ;
      Iterator fujaba__IterAssocSetMethod43ElementsUMLMethod45 = null ;
      Iterator fujaba__IterAssocSetMethod46ElementsUMLMethod47 = null ;
      Iterator fujaba__IterAssocSetMethod48ElementsUMLMethod49 = null ;
      Iterator fujaba__IterAssocSetMethod48ElementsUMLMethod50 = null ;
      Iterator fujaba__IterReference19AnnotationsAssocSetMethod33 = null ;
      Iterator fujaba__IterReference19AnnotationsAssocSetMethod36 = null ;
      Iterator fujaba__IterReference19AnnotationsAssocSetMethod46 = null ;
      Iterator fujaba__IterReference19AnnotationsAssocSetMethod48 = null ;
      Iterator fujaba__IterReference20AnnotationsAssocSetMethod25 = null ;
      Iterator fujaba__IterReference20AnnotationsAssocSetMethod28 = null ;
      Iterator fujaba__IterReference20AnnotationsAssocSetMethod41 = null ;
      Iterator fujaba__IterReference20AnnotationsAssocSetMethod43 = null ;
      Iterator fujaba__IterUMLMethod26AnnotationsAssocSetMethod27 = null ;
      Iterator fujaba__IterUMLMethod29AnnotationsAssocSetMethod30 = null ;
      Iterator fujaba__IterUMLMethod31AnnotationsAssocSetMethod32 = null ;
      Iterator fujaba__IterUMLMethod34AnnotationsAssocSetMethod35 = null ;
      Iterator fujaba__IterUMLMethod37AnnotationsAssocSetMethod38 = null ;
      Iterator fujaba__IterUMLMethod39AnnotationsAssocSetMethod40 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference19 = null ;
      ReferenceAnnotation reference20 = null ;
      UMLMethod uMLMethod26 = null ;
      UMLMethod uMLMethod29 = null ;
      UMLMethod uMLMethod31 = null ;
      UMLMethod uMLMethod34 = null ;
      UMLMethod uMLMethod37 = null ;
      UMLMethod uMLMethod39 = null ;
      UMLMethod uMLMethod42 = null ;
      UMLMethod uMLMethod44 = null ;
      UMLMethod uMLMethod45 = null ;
      UMLMethod uMLMethod47 = null ;
      UMLMethod uMLMethod49 = null ;
      UMLMethod uMLMethod50 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Reference") || annotation.equals ("QualifiedReference") || annotation.equals ("MultiReference") || annotation.equals ("SingleReference") || annotation.equals ("ArrayMultiReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference20 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod25: AssocSetMethodAnnotation
            fujaba__IterReference20AnnotationsAssocSetMethod25 = reference20.iteratorOfAnnotations () ;
            while ( fujaba__IterReference20AnnotationsAssocSetMethod25.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference20AnnotationsAssocSetMethod25.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod25 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod25 and reference20
                  JavaSDM.ensure ( assocSetMethod25.hasInElements ("reference", reference20) ) ;
                   
                  // bind uMLMethod26: UMLMethod
                  fujaba__IterAssocSetMethod25ElementsUMLMethod26 = assocSetMethod25.iteratorOfElements ("setMethod") ;
                  while ( fujaba__IterAssocSetMethod25ElementsUMLMethod26.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod25ElementsUMLMethod26.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod26 = (UMLMethod) fujaba__TmpObject ;
                         
                        // bind assocSetMethod27: AssocSetMethodAnnotation
                        fujaba__IterUMLMethod26AnnotationsAssocSetMethod27 = uMLMethod26.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod26AnnotationsAssocSetMethod27.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod26AnnotationsAssocSetMethod27.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                              assocSetMethod27 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between assocSetMethod27 and uMLMethod26
                              JavaSDM.ensure ( assocSetMethod27.hasInElements ("calledMethod", uMLMethod26) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(assocSetMethod25.equals (assocSetMethod27)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (assocSetMethod27);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference20 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod28: AssocSetMethodAnnotation
            fujaba__IterReference20AnnotationsAssocSetMethod28 = reference20.iteratorOfAnnotations () ;
            while ( fujaba__IterReference20AnnotationsAssocSetMethod28.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference20AnnotationsAssocSetMethod28.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod28 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod28 and reference20
                  JavaSDM.ensure ( assocSetMethod28.hasInElements ("reference", reference20) ) ;
                   
                  // bind uMLMethod29: UMLMethod
                  fujaba__IterAssocSetMethod28ElementsUMLMethod29 = assocSetMethod28.iteratorOfElements ("setMethod") ;
                  while ( fujaba__IterAssocSetMethod28ElementsUMLMethod29.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod28ElementsUMLMethod29.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod29 = (UMLMethod) fujaba__TmpObject ;
                         
                        // bind assocSetMethod30: AssocSetMethodAnnotation
                        fujaba__IterUMLMethod29AnnotationsAssocSetMethod30 = uMLMethod29.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod29AnnotationsAssocSetMethod30.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod29AnnotationsAssocSetMethod30.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                              assocSetMethod30 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between assocSetMethod30 and uMLMethod29
                              JavaSDM.ensure ( assocSetMethod30.hasInElements ("calledMethod", uMLMethod29) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(assocSetMethod28.equals (assocSetMethod30)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (assocSetMethod30);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssocSetMethodAnnotation ) ;
             
            // explicit type cast
            assocSetMethod30 = (AssocSetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (assocSetMethod30);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssocSetMethodAnnotation ) ;
             
            // explicit type cast
            assocSetMethod28 = (AssocSetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod31: UMLMethod
            fujaba__IterAssocSetMethod28ElementsUMLMethod31 = assocSetMethod28.iteratorOfElements ("setMethod") ;
            while ( fujaba__IterAssocSetMethod28ElementsUMLMethod31.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssocSetMethod28ElementsUMLMethod31.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod31 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind assocSetMethod32: AssocSetMethodAnnotation
                  fujaba__IterUMLMethod31AnnotationsAssocSetMethod32 = uMLMethod31.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod31AnnotationsAssocSetMethod32.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod31AnnotationsAssocSetMethod32.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                        assocSetMethod32 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between assocSetMethod32 and uMLMethod31
                        JavaSDM.ensure ( assocSetMethod32.hasInElements ("calledMethod", uMLMethod31) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(assocSetMethod28.equals (assocSetMethod32)) ) ;
                         
                        {
                           //  for each flow
                           set.add (assocSetMethod32);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Reference") || annotation.equals ("QualifiedReference") || annotation.equals ("MultiReference") || annotation.equals ("SingleReference") || annotation.equals ("ArrayMultiReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference19 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod33: AssocSetMethodAnnotation
            fujaba__IterReference19AnnotationsAssocSetMethod33 = reference19.iteratorOfAnnotations () ;
            while ( fujaba__IterReference19AnnotationsAssocSetMethod33.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference19AnnotationsAssocSetMethod33.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod33 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod33 and reference19
                  JavaSDM.ensure ( assocSetMethod33.hasInElements ("reference", reference19) ) ;
                   
                  // bind uMLMethod34: UMLMethod
                  fujaba__IterAssocSetMethod33ElementsUMLMethod34 = assocSetMethod33.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod33ElementsUMLMethod34.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod33ElementsUMLMethod34.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod34 = (UMLMethod) fujaba__TmpObject ;
                         
                        // bind assocSetMethod35: AssocSetMethodAnnotation
                        fujaba__IterUMLMethod34AnnotationsAssocSetMethod35 = uMLMethod34.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod34AnnotationsAssocSetMethod35.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod34AnnotationsAssocSetMethod35.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                              assocSetMethod35 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between assocSetMethod35 and uMLMethod34
                              JavaSDM.ensure ( assocSetMethod35.hasInElements ("setMethod", uMLMethod34) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(assocSetMethod33.equals (assocSetMethod35)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (assocSetMethod35);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference19 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod36: AssocSetMethodAnnotation
            fujaba__IterReference19AnnotationsAssocSetMethod36 = reference19.iteratorOfAnnotations () ;
            while ( fujaba__IterReference19AnnotationsAssocSetMethod36.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference19AnnotationsAssocSetMethod36.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod36 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod36 and reference19
                  JavaSDM.ensure ( assocSetMethod36.hasInElements ("reference", reference19) ) ;
                   
                  // bind uMLMethod37: UMLMethod
                  fujaba__IterAssocSetMethod36ElementsUMLMethod37 = assocSetMethod36.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod36ElementsUMLMethod37.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod36ElementsUMLMethod37.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod37 = (UMLMethod) fujaba__TmpObject ;
                         
                        // bind assocSetMethod38: AssocSetMethodAnnotation
                        fujaba__IterUMLMethod37AnnotationsAssocSetMethod38 = uMLMethod37.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod37AnnotationsAssocSetMethod38.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod37AnnotationsAssocSetMethod38.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                              assocSetMethod38 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between assocSetMethod38 and uMLMethod37
                              JavaSDM.ensure ( assocSetMethod38.hasInElements ("setMethod", uMLMethod37) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(assocSetMethod36.equals (assocSetMethod38)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (assocSetMethod38);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssocSetMethodAnnotation ) ;
             
            // explicit type cast
            assocSetMethod36 = (AssocSetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod39: UMLMethod
            fujaba__IterAssocSetMethod36ElementsUMLMethod39 = assocSetMethod36.iteratorOfElements ("calledMethod") ;
            while ( fujaba__IterAssocSetMethod36ElementsUMLMethod39.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssocSetMethod36ElementsUMLMethod39.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod39 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind assocSetMethod40: AssocSetMethodAnnotation
                  fujaba__IterUMLMethod39AnnotationsAssocSetMethod40 = uMLMethod39.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod39AnnotationsAssocSetMethod40.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod39AnnotationsAssocSetMethod40.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                        assocSetMethod40 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between assocSetMethod40 and uMLMethod39
                        JavaSDM.ensure ( assocSetMethod40.hasInElements ("setMethod", uMLMethod39) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(assocSetMethod36.equals (assocSetMethod40)) ) ;
                         
                        {
                           //  for each flow
                           set.add (assocSetMethod40);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssocSetMethodAnnotation ) ;
             
            // explicit type cast
            assocSetMethod40 = (AssocSetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (assocSetMethod40);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("AssocSetMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference19 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (reference19);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference20 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod41: AssocSetMethodAnnotation
            fujaba__IterReference20AnnotationsAssocSetMethod41 = reference20.iteratorOfAnnotations () ;
            while ( fujaba__IterReference20AnnotationsAssocSetMethod41.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference20AnnotationsAssocSetMethod41.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod41 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod41 and reference20
                  JavaSDM.ensure ( assocSetMethod41.hasInElements ("reference", reference20) ) ;
                   
                  // bind uMLMethod42: UMLMethod
                  fujaba__IterAssocSetMethod41ElementsUMLMethod42 = assocSetMethod41.iteratorOfElements ("setMethod") ;
                  while ( fujaba__IterAssocSetMethod41ElementsUMLMethod42.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod41ElementsUMLMethod42.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod42 = (UMLMethod) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod42);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference19 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (reference19);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference20 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod43: AssocSetMethodAnnotation
            fujaba__IterReference20AnnotationsAssocSetMethod43 = reference20.iteratorOfAnnotations () ;
            while ( fujaba__IterReference20AnnotationsAssocSetMethod43.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference20AnnotationsAssocSetMethod43.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod43 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod43 and reference20
                  JavaSDM.ensure ( assocSetMethod43.hasInElements ("reference", reference20) ) ;
                   
                  // bind uMLMethod44: UMLMethod
                  fujaba__IterAssocSetMethod43ElementsUMLMethod44 = assocSetMethod43.iteratorOfElements ("setMethod") ;
                  while ( fujaba__IterAssocSetMethod43ElementsUMLMethod44.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod43ElementsUMLMethod44.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod44 = (UMLMethod) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod44);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssocSetMethodAnnotation ) ;
             
            // explicit type cast
            assocSetMethod43 = (AssocSetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod45: UMLMethod
            fujaba__IterAssocSetMethod43ElementsUMLMethod45 = assocSetMethod43.iteratorOfElements ("setMethod") ;
            while ( fujaba__IterAssocSetMethod43ElementsUMLMethod45.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssocSetMethod43ElementsUMLMethod45.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod45 = (UMLMethod) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod45);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("AssocSetMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference19 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod46: AssocSetMethodAnnotation
            fujaba__IterReference19AnnotationsAssocSetMethod46 = reference19.iteratorOfAnnotations () ;
            while ( fujaba__IterReference19AnnotationsAssocSetMethod46.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference19AnnotationsAssocSetMethod46.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod46 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod46 and reference19
                  JavaSDM.ensure ( assocSetMethod46.hasInElements ("reference", reference19) ) ;
                   
                  // bind uMLMethod47: UMLMethod
                  fujaba__IterAssocSetMethod46ElementsUMLMethod47 = assocSetMethod46.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod46ElementsUMLMethod47.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod46ElementsUMLMethod47.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod47 = (UMLMethod) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod47);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference20 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (reference20);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference19 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod48: AssocSetMethodAnnotation
            fujaba__IterReference19AnnotationsAssocSetMethod48 = reference19.iteratorOfAnnotations () ;
            while ( fujaba__IterReference19AnnotationsAssocSetMethod48.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference19AnnotationsAssocSetMethod48.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod48 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod48 and reference19
                  JavaSDM.ensure ( assocSetMethod48.hasInElements ("reference", reference19) ) ;
                   
                  // bind uMLMethod49: UMLMethod
                  fujaba__IterAssocSetMethod48ElementsUMLMethod49 = assocSetMethod48.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod48ElementsUMLMethod49.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod48ElementsUMLMethod49.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod49 = (UMLMethod) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod49);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference20 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (reference20);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssocSetMethodAnnotation ) ;
             
            // explicit type cast
            assocSetMethod48 = (AssocSetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod50: UMLMethod
            fujaba__IterAssocSetMethod48ElementsUMLMethod50 = assocSetMethod48.iteratorOfElements ("calledMethod") ;
            while ( fujaba__IterAssocSetMethod48ElementsUMLMethod50.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssocSetMethod48ElementsUMLMethod50.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod50 = (UMLMethod) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod50);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
