package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLParam;
import de.upb.javaast.methodast.references.UMLDeclarationToIdentifierNodeRef;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLType;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.upb.javaast.methodast.PrimaryExpressionNode;
import de.upb.javaast.methodast.IdentifierNode;
import de.upb.javaast.methodast.AssignmentNode;
import de.upb.javaast.methodast.RootBlockNode;

public class SetMethodEngine
extends GFRNEngine
{
   private  SetMethodEngine()
   {
   }

   private static SetMethodEngine theSetMethodEngine;

   public static SetMethodEngine get()
   {
      if (theSetMethodEngine == null)
      {
         theSetMethodEngine = new SetMethodEngine ();
      }
      return theSetMethodEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation setMethod = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         setMethod = this.annotateUsingFieldRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( setMethod != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (setMethod) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            setMethod = this.annotateUsingMethodRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         return (setMethod) ;
      }
   }


   private GFRNAnnotation annotateUsingFieldRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterLeftExpressionToAttrVariable = null ;
      ASTPathVisitor fujaba__IterRootBlockNode5ToAssignmentNode4 = null ;
      de.upb.javaast.methodast.AssignmentNode assignmentNode4 = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAttrTypeRevParamTypeUMLParam1 = null ;
      Iterator fujaba__IterAttributeElementReferencesUMLDeclarationToIdentifierNodeRef3 = null ;
      Iterator fujaba__IterMethodAnnotationsSetMethod = null ;
      Iterator fujaba__IterUMLParam1ElementReferencesUMLDeclarationToIdentifierNodeRef2 = null ;
      de.upb.javaast.methodast.IdentifierNode attrVariable = null ;
      IdentifierNode paramVariable = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      PrimaryExpressionNode leftExpression = null ;
      PrimaryExpressionNode rightExpression = null ;
      RootBlockNode rootBlockNode5 = null ;
      SetMethodAnnotation setMethod = null ;
      UMLAttr attribute = null ;
      UMLClass clazz = null ;
      UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef2 = null ;
      UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef3 = null ;
      UMLMethod method = null ;
      UMLParam uMLParam1 = null ;
      UMLType attrType = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            attribute = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind attrType: UMLType
            attrType = attribute.getAttrType () ;
            JavaSDM.ensure ( attrType != null ) ;
             
            // bind clazz: UMLClass
            clazz = attribute.getParent () ;
            JavaSDM.ensure ( clazz != null ) ;
             
            // bind uMLDeclarationToIdentifierNodeRef3: UMLDeclarationToIdentifierNodeRef
            fujaba__IterAttributeElementReferencesUMLDeclarationToIdentifierNodeRef3 = attribute.iteratorOfElementReferences () ;
            while ( fujaba__IterAttributeElementReferencesUMLDeclarationToIdentifierNodeRef3.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAttributeElementReferencesUMLDeclarationToIdentifierNodeRef3.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.upb.javaast.methodast.references.UMLDeclarationToIdentifierNodeRef ) ;
                  uMLDeclarationToIdentifierNodeRef3 = (UMLDeclarationToIdentifierNodeRef) fujaba__TmpObject ;
                   
                  // bind uMLParam1: UMLParam
                  fujaba__IterAttrTypeRevParamTypeUMLParam1 = attrType.iteratorOfRevParamType () ;
                  while ( fujaba__IterAttrTypeRevParamTypeUMLParam1.hasNext () )
                  {
                     try
                     {
                        uMLParam1 = (UMLParam) fujaba__IterAttrTypeRevParamTypeUMLParam1.next () ;
                         
                        // bind method: UMLMethod
                        method = uMLParam1.getRevParam () ;
                        JavaSDM.ensure ( method != null ) ;
                         
                        // check To-One-Link 'parent' between method and clazz
                        JavaSDM.ensure ( (method.getParent () != null) && method.getParent ().equals (clazz) ) ;
                         
                        // bind rootBlockNode5: RootBlockNode
                        fujaba__TmpObject = method.getASTRootNode () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.RootBlockNode ) ;
                        rootBlockNode5 = (RootBlockNode) fujaba__TmpObject ;
                         
                        // bind uMLDeclarationToIdentifierNodeRef2: UMLDeclarationToIdentifierNodeRef
                        fujaba__IterUMLParam1ElementReferencesUMLDeclarationToIdentifierNodeRef2 = uMLParam1.iteratorOfElementReferences () ;
                        while ( fujaba__IterUMLParam1ElementReferencesUMLDeclarationToIdentifierNodeRef2.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLParam1ElementReferencesUMLDeclarationToIdentifierNodeRef2.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.upb.javaast.methodast.references.UMLDeclarationToIdentifierNodeRef ) ;
                              uMLDeclarationToIdentifierNodeRef2 = (UMLDeclarationToIdentifierNodeRef) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLDeclarationToIdentifierNodeRef3.equals (uMLDeclarationToIdentifierNodeRef2)) ) ;
                               
                              // Path search between RootBlockNode and AssignmentNode
                              // Bind assignmentNode4 : AssignmentNode
                              fujaba__IterRootBlockNode5ToAssignmentNode4 = new ASTPathVisitor (rootBlockNode5, AssignmentNode.class ) ;
                              while ( fujaba__IterRootBlockNode5ToAssignmentNode4.hasNext () )
                              {
                                 try
                                 {
                                    assignmentNode4 = (de.upb.javaast.methodast.AssignmentNode) fujaba__IterRootBlockNode5ToAssignmentNode4.next () ;
                                     
                                    // bind leftExpression: PrimaryExpressionNode
                                    fujaba__TmpObject = assignmentNode4.getLeftExpression () ;
                                    JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                                    leftExpression = (PrimaryExpressionNode) fujaba__TmpObject ;
                                     
                                    // bind rightExpression: PrimaryExpressionNode
                                    fujaba__TmpObject = assignmentNode4.getRightExpression () ;
                                    JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                                    rightExpression = (PrimaryExpressionNode) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(leftExpression.equals (rightExpression)) ) ;
                                     
                                    // bind paramVariable: IdentifierNode
                                    paramVariable = rightExpression.getIdentifier () ;
                                    JavaSDM.ensure ( paramVariable != null ) ;
                                     
                                    // check To-One-Link 'umlDeclarationRef' between paramVariable and uMLDeclarationToIdentifierNodeRef2
                                    JavaSDM.ensure ( (paramVariable.getUmlDeclarationRef () != null) && paramVariable.getUmlDeclarationRef ().equals (uMLDeclarationToIdentifierNodeRef2) ) ;
                                     
                                    // Path search between PrimaryExpressionNode and IdentifierNode
                                    // Bind attrVariable : IdentifierNode
                                    fujaba__IterLeftExpressionToAttrVariable = new ASTPathVisitor (leftExpression, IdentifierNode.class ) ;
                                    while ( fujaba__IterLeftExpressionToAttrVariable.hasNext () )
                                    {
                                       try
                                       {
                                          attrVariable = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterLeftExpressionToAttrVariable.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(paramVariable.equals (attrVariable)) ) ;
                                           
                                          // check To-One-Link 'umlDeclarationRef' between attrVariable and uMLDeclarationToIdentifierNodeRef3
                                          JavaSDM.ensure ( (attrVariable.getUmlDeclarationRef () != null) && attrVariable.getUmlDeclarationRef ().equals (uMLDeclarationToIdentifierNodeRef3) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object method is really bound
                                                JavaSDM.ensure ( method != null ) ;
                                                 
                                                // check object attribute is really bound
                                                JavaSDM.ensure ( attribute != null ) ;
                                                 
                                                // bind setMethod: SetMethodAnnotation
                                                fujaba__IterMethodAnnotationsSetMethod = method.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterMethodAnnotationsSetMethod.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterMethodAnnotationsSetMethod.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                                      setMethod = (SetMethodAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between setMethod and method
                                                      JavaSDM.ensure ( setMethod.hasInElements ("method", method) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between setMethod and attribute
                                                      JavaSDM.ensure ( setMethod.hasInElements ("field", attribute) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object method is really bound
                                                   JavaSDM.ensure ( method != null ) ;
                                                    
                                                   // check object attribute is really bound
                                                   JavaSDM.ensure ( attribute != null ) ;
                                                    
                                                   // check object attrType is really bound
                                                   JavaSDM.ensure ( attrType != null ) ;
                                                    
                                                   // check object clazz is really bound
                                                   JavaSDM.ensure ( clazz != null ) ;
                                                    
                                                   // check object leftExpression is really bound
                                                   JavaSDM.ensure ( leftExpression != null ) ;
                                                    
                                                   // check object attrVariable is really bound
                                                   JavaSDM.ensure ( attrVariable != null ) ;
                                                    
                                                   // check object rightExpression is really bound
                                                   JavaSDM.ensure ( rightExpression != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(leftExpression.equals (rightExpression)) ) ;
                                                    
                                                   // check object paramVariable is really bound
                                                   JavaSDM.ensure ( paramVariable != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(attrVariable.equals (paramVariable)) ) ;
                                                    
                                                   // create object
                                                   setMethod = new SetMethodAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   setMethod.setClassification (0);
                                                    
                                                   // create link
                                                   setMethod.addToElements ("method", method);
                                                    
                                                   // create link
                                                   setMethod.addToElements ("field", attribute);
                                                    
                                                   // create link
                                                   setMethod.addToBoundObjects ("attribute", attribute);
                                                    
                                                   // create link
                                                   setMethod.addToBoundObjects ("attrType", attrType);
                                                    
                                                   // create link
                                                   setMethod.addToBoundObjects ("method", method);
                                                    
                                                   // create link
                                                   setMethod.addToBoundObjects ("clazz", clazz);
                                                    
                                                   // create link
                                                   setMethod.addToBoundObjects ("leftExpression", leftExpression);
                                                    
                                                   // create link
                                                   setMethod.addToBoundObjects ("attrVariable", attrVariable);
                                                    
                                                   // create link
                                                   setMethod.addToBoundObjects ("rightExpression", rightExpression);
                                                    
                                                   // create link
                                                   setMethod.addToBoundObjects ("paramVariable", paramVariable);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (setMethod) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object setMethod is really bound
            JavaSDM.ensure ( setMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (setMethod) ;
   }


   private GFRNAnnotation annotateUsingMethodRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterLeftExpressionToAttrVariable = null ;
      ASTPathVisitor fujaba__IterRootBlockNode10ToAssignmentNode9 = null ;
      de.upb.javaast.methodast.AssignmentNode assignmentNode9 = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAttributeElementReferencesUMLDeclarationToIdentifierNodeRef8 = null ;
      Iterator fujaba__IterClazzAttrsAttribute = null ;
      Iterator fujaba__IterMethodAnnotationsSetMethod = null ;
      Iterator fujaba__IterMethodParamUMLParam6 = null ;
      Iterator fujaba__IterUMLParam6ElementReferencesUMLDeclarationToIdentifierNodeRef7 = null ;
      de.upb.javaast.methodast.IdentifierNode attrVariable = null ;
      IdentifierNode paramVariable = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      PrimaryExpressionNode leftExpression = null ;
      PrimaryExpressionNode rightExpression = null ;
      RootBlockNode rootBlockNode10 = null ;
      SetMethodAnnotation setMethod = null ;
      UMLAttr attribute = null ;
      UMLClass clazz = null ;
      UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef7 = null ;
      UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef8 = null ;
      UMLMethod method = null ;
      UMLParam uMLParam6 = null ;
      UMLType attrType = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            method = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind rootBlockNode10: RootBlockNode
            fujaba__TmpObject = method.getASTRootNode () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.RootBlockNode ) ;
            rootBlockNode10 = (RootBlockNode) fujaba__TmpObject ;
             
            // bind clazz: UMLClass
            clazz = method.getParent () ;
            JavaSDM.ensure ( clazz != null ) ;
             
            // bind uMLParam6: UMLParam
            fujaba__IterMethodParamUMLParam6 = method.iteratorOfParam () ;
            while ( fujaba__IterMethodParamUMLParam6.hasNext () )
            {
               try
               {
                  uMLParam6 = (UMLParam) fujaba__IterMethodParamUMLParam6.next () ;
                   
                  // bind attrType: UMLType
                  attrType = uMLParam6.getParamType () ;
                  JavaSDM.ensure ( attrType != null ) ;
                   
                  // bind attribute: UMLAttr
                  fujaba__IterClazzAttrsAttribute = clazz.iteratorOfAttrs () ;
                  while ( fujaba__IterClazzAttrsAttribute.hasNext () )
                  {
                     try
                     {
                        attribute = (UMLAttr) fujaba__IterClazzAttrsAttribute.next () ;
                         
                        // check To-One-Link 'attrType' between attribute and attrType
                        JavaSDM.ensure ( (attribute.getAttrType () != null) && attribute.getAttrType ().equals (attrType) ) ;
                         
                        // bind uMLDeclarationToIdentifierNodeRef7: UMLDeclarationToIdentifierNodeRef
                        fujaba__IterUMLParam6ElementReferencesUMLDeclarationToIdentifierNodeRef7 = uMLParam6.iteratorOfElementReferences () ;
                        while ( fujaba__IterUMLParam6ElementReferencesUMLDeclarationToIdentifierNodeRef7.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLParam6ElementReferencesUMLDeclarationToIdentifierNodeRef7.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.upb.javaast.methodast.references.UMLDeclarationToIdentifierNodeRef ) ;
                              uMLDeclarationToIdentifierNodeRef7 = (UMLDeclarationToIdentifierNodeRef) fujaba__TmpObject ;
                               
                              // bind uMLDeclarationToIdentifierNodeRef8: UMLDeclarationToIdentifierNodeRef
                              fujaba__IterAttributeElementReferencesUMLDeclarationToIdentifierNodeRef8 = attribute.iteratorOfElementReferences () ;
                              while ( fujaba__IterAttributeElementReferencesUMLDeclarationToIdentifierNodeRef8.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAttributeElementReferencesUMLDeclarationToIdentifierNodeRef8.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.upb.javaast.methodast.references.UMLDeclarationToIdentifierNodeRef ) ;
                                    uMLDeclarationToIdentifierNodeRef8 = (UMLDeclarationToIdentifierNodeRef) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLDeclarationToIdentifierNodeRef7.equals (uMLDeclarationToIdentifierNodeRef8)) ) ;
                                     
                                    // Path search between RootBlockNode and AssignmentNode
                                    // Bind assignmentNode9 : AssignmentNode
                                    fujaba__IterRootBlockNode10ToAssignmentNode9 = new ASTPathVisitor (rootBlockNode10, AssignmentNode.class ) ;
                                    while ( fujaba__IterRootBlockNode10ToAssignmentNode9.hasNext () )
                                    {
                                       try
                                       {
                                          assignmentNode9 = (de.upb.javaast.methodast.AssignmentNode) fujaba__IterRootBlockNode10ToAssignmentNode9.next () ;
                                           
                                          // bind rightExpression: PrimaryExpressionNode
                                          fujaba__TmpObject = assignmentNode9.getRightExpression () ;
                                          JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                                          rightExpression = (PrimaryExpressionNode) fujaba__TmpObject ;
                                           
                                          // bind leftExpression: PrimaryExpressionNode
                                          fujaba__TmpObject = assignmentNode9.getLeftExpression () ;
                                          JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                                          leftExpression = (PrimaryExpressionNode) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(rightExpression.equals (leftExpression)) ) ;
                                           
                                          // bind paramVariable: IdentifierNode
                                          paramVariable = rightExpression.getIdentifier () ;
                                          JavaSDM.ensure ( paramVariable != null ) ;
                                           
                                          // check To-One-Link 'umlDeclarationRef' between paramVariable and uMLDeclarationToIdentifierNodeRef7
                                          JavaSDM.ensure ( (paramVariable.getUmlDeclarationRef () != null) && paramVariable.getUmlDeclarationRef ().equals (uMLDeclarationToIdentifierNodeRef7) ) ;
                                           
                                          // Path search between PrimaryExpressionNode and IdentifierNode
                                          // Bind attrVariable : IdentifierNode
                                          fujaba__IterLeftExpressionToAttrVariable = new ASTPathVisitor (leftExpression, IdentifierNode.class ) ;
                                          while ( fujaba__IterLeftExpressionToAttrVariable.hasNext () )
                                          {
                                             try
                                             {
                                                attrVariable = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterLeftExpressionToAttrVariable.next () ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(paramVariable.equals (attrVariable)) ) ;
                                                 
                                                // check To-One-Link 'umlDeclarationRef' between attrVariable and uMLDeclarationToIdentifierNodeRef8
                                                JavaSDM.ensure ( (attrVariable.getUmlDeclarationRef () != null) && attrVariable.getUmlDeclarationRef ().equals (uMLDeclarationToIdentifierNodeRef8) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object method is really bound
                                                      JavaSDM.ensure ( method != null ) ;
                                                       
                                                      // check object attribute is really bound
                                                      JavaSDM.ensure ( attribute != null ) ;
                                                       
                                                      // bind setMethod: SetMethodAnnotation
                                                      fujaba__IterMethodAnnotationsSetMethod = method.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterMethodAnnotationsSetMethod.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterMethodAnnotationsSetMethod.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                                            setMethod = (SetMethodAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between setMethod and method
                                                            JavaSDM.ensure ( setMethod.hasInElements ("method", method) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between setMethod and attribute
                                                            JavaSDM.ensure ( setMethod.hasInElements ("field", attribute) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object method is really bound
                                                         JavaSDM.ensure ( method != null ) ;
                                                          
                                                         // check object attribute is really bound
                                                         JavaSDM.ensure ( attribute != null ) ;
                                                          
                                                         // check object attrType is really bound
                                                         JavaSDM.ensure ( attrType != null ) ;
                                                          
                                                         // check object clazz is really bound
                                                         JavaSDM.ensure ( clazz != null ) ;
                                                          
                                                         // check object leftExpression is really bound
                                                         JavaSDM.ensure ( leftExpression != null ) ;
                                                          
                                                         // check object attrVariable is really bound
                                                         JavaSDM.ensure ( attrVariable != null ) ;
                                                          
                                                         // check object rightExpression is really bound
                                                         JavaSDM.ensure ( rightExpression != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(leftExpression.equals (rightExpression)) ) ;
                                                          
                                                         // check object paramVariable is really bound
                                                         JavaSDM.ensure ( paramVariable != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(attrVariable.equals (paramVariable)) ) ;
                                                          
                                                         // create object
                                                         setMethod = new SetMethodAnnotation ( ) ;
                                                          
                                                         // assign statement
                                                         setMethod.setClassification (0);
                                                          
                                                         // create link
                                                         setMethod.addToElements ("method", method);
                                                          
                                                         // create link
                                                         setMethod.addToElements ("field", attribute);
                                                          
                                                         // create link
                                                         setMethod.addToBoundObjects ("attribute", attribute);
                                                          
                                                         // create link
                                                         setMethod.addToBoundObjects ("attrType", attrType);
                                                          
                                                         // create link
                                                         setMethod.addToBoundObjects ("method", method);
                                                          
                                                         // create link
                                                         setMethod.addToBoundObjects ("clazz", clazz);
                                                          
                                                         // create link
                                                         setMethod.addToBoundObjects ("leftExpression", leftExpression);
                                                          
                                                         // create link
                                                         setMethod.addToBoundObjects ("attrVariable", attrVariable);
                                                          
                                                         // create link
                                                         setMethod.addToBoundObjects ("rightExpression", rightExpression);
                                                          
                                                         // create link
                                                         setMethod.addToBoundObjects ("paramVariable", paramVariable);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (setMethod) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object setMethod is really bound
            JavaSDM.ensure ( setMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (setMethod) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
