/*
 * The FUJABA [Just Draw It!] project:
 *
 *   FUJABA is the acronym for 'From Uml to Java And Back Again'
 *   and originally aims to provide an environment for round-trip
 *   engineering using UML as visual programming language. During
 *   the last years, the environment has become a base for several
 *   research activities, e.g. distributed software, database
 *   systems, modelling mechanical and electrical systems and
 *   their simulation. Thus, the environment has become a project,
 *   where this source code is part of. Further details are avail-
 *   able via http://www.fujaba.de
 *
 *      Copyright (C) 1997-2002 Fujaba Development Group
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA 02111-1307, USA or download the license under
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * WARRANTY:
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Lesser General Public License for more details.
 *
 * Contact adress:
 *
 *   Fujaba Management Board
 *   Software Engineering Group
 *   University of Paderborn
 *   Warburgerstr. 100
 *   D-33098 Paderborn
 *   Germany
 *
 *   URL  : http://www.fujaba.de
 *   email: fujaba@upb.de
 *
 */
package de.upb.lib.html;

import java.awt.*;

import javax.swing.*;


/**
 * No comment provided by developer, please add a comment to improve documentation.
 *
 * @author    $Author: lowende $
 * @version   $Revision: 1.2 $
 */
public class HtmlBrowser extends JFrame
{
   /**
    * The main program for the HtmlBrowser class
    *
    * @param args  The command line arguments
    */
   public static void main (String[] args)
   {
      theBrowser = new HtmlBrowser (args);
      theBrowser.show();
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public static HtmlBrowser theBrowser = null;

   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public HtmlPanel htmlPanel = null;


   /**
    * Get the preferredSize attribute of the HtmlBrowser object
    *
    * @return   The preferredSize value
    */
   public Dimension getPreferredSize()
   {
      return new Dimension (500, 700);
   }


   /**
    * Constructor for class HtmlBrowser
    *
    * @param startUrl  No description provided
    */
   public HtmlBrowser (String startUrl)
   {
      htmlPanel = new HtmlPanel (startUrl);
      htmlPanel.setSize (500, 700);
      getContentPane().add (htmlPanel);
      pack();
   }


   /**
    * Constructor for class HtmlBrowser
    *
    * @param args  No description provided
    */
   public HtmlBrowser (String[] args)
   {
      super ("test java browser");

      htmlPanel = new HtmlPanel (args[0]);
      htmlPanel.setSize (500, 700);
      getContentPane().add (htmlPanel);
      pack();
   }
}

/*
 * $Log: HtmlBrowser.java,v $
 * Revision 1.2  2004/08/02 07:34:14  lowende
 * Getter method for class loader chain of UPBClassloader added. Javadoc corrected.
 *
 */
